import java.util.*;
/**
 * Given an input of up to 1,000,000 million binary strings 
 * find the number of pairs of complementary strings.
 * 
 * @author Greg Ballinger
 */
public class CompBinaryStrings
{
    
    public static int BinaryStringToInt(String s)
    {
        int result = 0;
        for(int i = 0; i < s.length() ; i++)
        {
            result <<= 1;
            if (s.charAt(i) == '1') result += 1;
        }
        return result;            
    }
    
    public static void processSet(Scanner in)
    {
        int numComplementaryPairs = 0;
        int numInputs = in.nextInt();
        int[] binValues = new int[numInputs];
        String firstIn = in.next();
        int len = firstIn.length();
        int maxXOR =  (int)Math.pow(2,len) - 1;
        binValues[0] = BinaryStringToInt (firstIn);
        // input remaining Strings
        for (int i = 1; i < numInputs ; i++)
        {
            binValues[i] = BinaryStringToInt(in.next());
        }
        for (int i = 0; i < numInputs - 1; i++)
        {
            for (int j = i + 1; j < numInputs; j++ )
            {
                if ( (binValues[i]^binValues[j]) == maxXOR ) numComplementaryPairs++;
            }
        }
        System.out.println(numComplementaryPairs);
    }

    public static void main(String[] args) 
    {
        Scanner in = new Scanner(System.in);
        int numSets = in.nextInt();
        for (int set  = 0 ; set < numSets; set++)
        {
            processSet(in);
        }
    }
        
}
