// CountingBaseSeven.java - by Kip Irvine

// 2013 FIU HS Programming competition
// Generate all base-7 values from S to E, inclusive

import java.util.*;

public class CountingBaseSeven {

	// create a string from a character array
	String makeString(char[] v)  {
		StringBuilder str = new StringBuilder();
		for(int i=0; i< v.length; i++)
			str.append(v[i]);	
		return str.toString();
	}
	
	// increment a base-7 digit array
	void increment(char[] v) {
		
		int i = v.length - 1;
		while( i >= 0)  {
			assert( v[i] >= '0' && v[i] <= '6');
			if( v[i] < '6') {
				v[i]++;
				break;
			}
			else {
				v[i--] = '0';			
			}
		}  // while
	}  // increment
	

	void start() {
		Scanner in = new Scanner(System.in);
		String firstStr = in.next();
		String lastStr = in.next();	
		char[] v = firstStr.toCharArray();
		
		System.out.println( firstStr );
		while( !firstStr.equals(lastStr)) {
			increment(v);
			firstStr = makeString(v);
			System.out.println( firstStr );
		}
	}  // start
	
	public static void main(String[] args) {
		new CountingBaseSeven().start();
	}
}
