//  DogGopher.java
//  Judges solution to the Dog and Gopher problem

import java.util.Scanner;

public class DogGopher
{
	/**
	 * Calculates the distance between (x1,y1) and (x2,y2)
	 */
	public static double getDistance( double x1, double y1, double x2, double y2 )
    {
        return Math.sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
    }

	 /**
	  * Returns true if the gopher will escape from the dog.
	  * @param distanceG Distance of the gopher from the hole
	  * @param distanceD Distance of the dog from the hole
	  */
    public static boolean willEscape( double distanceG, double distanceD )
    {
        return (distanceG*2) < distanceD;
    }
  
    public static void main( String [] args )
    {
        Scanner input = new Scanner( System.in ); 
        int numHoles;
        double xg, yg, xd, yd, xh, yh;
        double distanceG, distanceD;
        boolean canEscape;

        int numTimes = input.nextInt();

        for( int z = 0; z < numTimes; z++)   {
            numHoles = input.nextInt();
            canEscape = false;
            xg = input.nextDouble();
            yg = input.nextDouble();
            xd = input.nextDouble();
            yd = input.nextDouble();

            for ( int i = 0; i < numHoles; i++ )  {
                xh = input.nextDouble();
                yh = input.nextDouble();
                distanceG = getDistance( xg, yg, xh, yh );
                distanceD = getDistance( xd, yd, xh, yh );

                if ( willEscape( distanceG, distanceD ) ) {
                    canEscape = true;
                    System.out.println( "The gopher can escape through the " +
                                        "hole at (" +
                                        String.format( "%.3f", xh) + "," +
                                        String.format( "%.3f", yh) + ")." );
                    break;
                }
                input.nextLine();               
            }
            if ( canEscape == false )
            	System.out.println( "The gopher cannot escape." );
        }
    }

}